package net.sourceforge.noadsunpacker.core;

/**
 * This is the class of exceptions thrown by TMFPUnpackManager.
 * They are not supposed to be rethrown by ArchiveUnpackManager,
 * it should report errors to ArchiveUnpackManagerreportReceiver
 * instead.
 *
 * @author Fedor Uvarov
 */
public class UnpackException extends Exception {
public static final int REASON_UNPACKBLOCK_EOF = 1;
public static final int REASON_UNPACKBLOCK_IOEXCEPTION = 2;
public static final int REASON_CONTINUEUNPACKBLOCK_EOF = 3;
public static final int REASON_CONTINUEUNPACKBLOCK_IOEXCEPTION = 4;
public static final int REASON_OPENNEXTSOURCE_FAILED = 5;
public static final int REASON_READFILETABLE_EOF = 6;
public static final int REASON_READFILETABLE_IOEXCEPTION = 7;
public static final int REASON_UNPACK_NOMEMORY = 8;
public static final int REASON_CONTINUEUNPACKBLOCK_OVERREAD = 9;
public static final int REASON_CONTINUEUNPACKBLOCK_INTERRUPTEDEXCEPTION = 10;
public static final int REASON_INTERNAL_UNPACK_ABORTED = 11;
public static final int REASON_UNPACK_SIZE_ASSESSMENT_FAILED = 12;
public static final int REASON_SKIPBLOCK_EOF = 13;
public static final int REASON_SKIPBLOCK_IOEXCEPTION = 14;
private int Reason;
private String FilePath;
private Throwable WrappedException;

public UnpackException(int Reason, String FilePath) {
    this.Reason = Reason;
    this.FilePath = FilePath;
    this.WrappedException = null;
}

public UnpackException(int Reason, String FilePath, Throwable e) {
    super(e);
    this.Reason = Reason;
    this.FilePath = FilePath;
    this.WrappedException = e;
}

public void setFilePath(String FilePath) {
    this.FilePath = FilePath;
}

public int getReason() {
    return Reason;
}
}
