package net.sourceforge.noadsunpacker.gui;

import java.awt.Desktop;
import java.awt.GridLayout;
import java.io.IOException;
import java.net.URI;
import java.net.URL;
import javax.swing.JFrame;
import javax.swing.JEditorPane;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkEvent.EventType;
import javax.swing.event.HyperlinkListener;

/**
 * This is a window to show HTML help.
 *
 * @author Fedor Uvarov
 */
public class HelpFrame extends JFrame {
private final HelpFrame ThisFrame = this;
private JEditorPane UsedPane;
private Desktop CurrentDesktop = null;
private final URL ResourceURL = ClassLoader.getSystemResource("HELP.html");

public HelpFrame() throws IOException {
    this.setTitle("NoAds FileUnpacker 0.1.0 Help");
    this.setLayout(new GridLayout(1, 1));
    if(Desktop.isDesktopSupported()) {
        CurrentDesktop = Desktop.getDesktop();
    }
    UsedPane = new JEditorPane(ResourceURL);
    UsedPane.setEditable(false);
    UsedPane.addHyperlinkListener(new HyperlinkListener () {
        public void hyperlinkUpdate(HyperlinkEvent e) {
            if(e.getEventType() != EventType.ACTIVATED)return;
            URI eURI = null;
            try {
                eURI = e.getURL().toURI();
                if(CurrentDesktop == null) {
                    showErrorMessage(eURI.getPath());
                }
                else {
                    CurrentDesktop.browse(eURI);
                }
            }
            catch(Exception e2) {
                if(eURI == null) showErrorMessage("(cannot even detect URL)");
                else showErrorMessage(eURI.getPath());
            }
        }

        private void showErrorMessage(String url) {
            JOptionPane.showMessageDialog(ThisFrame, "Cannot open the URL" +
                    "in your default browser. Please open it manually.\n\nURL: "+url, "Error", JOptionPane.WARNING_MESSAGE);
        }
    });
    this.add(new JScrollPane(UsedPane, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));
    this.pack();
    this.setLocationRelativeTo(null);
}
}
